---
title: translateZ()
slug: Web/CSS/transform-function/translateZ()
tags:
  - 3D
  - CSS
  - CSS Function
  - CSS Transforms
  - Function
  - Reference
---
<div>{{CSSRef}}</div>

<p>The <strong><code>translateZ()</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/CSS_Functions">function</a> repositions an element along the z-axis in 3D space, i.e., closer to or farther away from the viewer. Its result is a {{cssxref("&lt;transform-function&gt;")}} data type.</p>

<div>{{EmbedInteractiveExample("pages/css/function-translateZ.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<p>This transformation is defined by a {{cssxref("&lt;length&gt;")}} which specifies how far inward or outward the element or elements move.</p>

<p>In the above interactive examples, <code><a href="/en-US/docs/Web/CSS/perspective">perspective: 550px;</a></code> (to create a 3D space) and <code><a href="/en-US/docs/Web/CSS/transform-style">transform-style: preserve-3d;</a></code> (so the children, the 6 sides of the cube, are also positioned in the 3D space), have been set on the cube.</p>

<div class="note">
<p><strong>Note:</strong> <code>translateZ(tz)</code> is equivalent to <code><a href="/en-US/docs/Web/CSS/transform-function/translate3d">translate3d</a>(0, 0, tz)</code>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">translateZ(<var>tz</var>)
</pre>

<h3 id="Values">Values</h3>

<dl>
 <dt><code><var>tz</var></code></dt>
 <dd>A {{cssxref("&lt;length&gt;")}} representing the z-component of the translating vector. A positive value moves the element towards the viewer, and a negative value farther away.</dd>
</dl>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Cartesian coordinates on ℝ<sup>2</sup></th>
   <th scope="col">Homogeneous coordinates on ℝℙ<sup>2</sup></th>
   <th scope="col">Cartesian coordinates on ℝ<sup>3</sup></th>
   <th scope="col">Homogeneous coordinates on ℝℙ<sup>3</sup></th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td colspan="2" rowspan="2">This transformation applies to the 3D space and can't be represented on the plane.</td>
   <td colspan="1" rowspan="2">A translation is not a linear transformation in ℝ<sup>3</sup> and can't be represented using a Cartesian-coordinate matrix.</td>
   <td colspan="1" rowspan="2"><math> <mfenced><mtable><mtr>1<mtd>0</mtd><mtd>0</mtd><mtd>0</mtd></mtr><mtr>0<mtd>1</mtd><mtd>0</mtd><mtd>0</mtd></mtr><mtr><mtd>0</mtd><mtd>0</mtd><mtd>1</mtd><mtd>t</mtd></mtr><mtr><mtd>0</mtd><mtd>0</mtd><mtd>0</mtd><mtd>1</mtd></mtr></mtable> </mfenced> </math></td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>In this example, two boxes are created. One is positioned normally on the page, without being translated at all. The second is altered by applying perspective to create a 3D space, then moved towards the user.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;div&gt;Static&lt;/div&gt;
&lt;div class="moved"&gt;Moved&lt;/div&gt;</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css notranslate">div {
  position: relative;
  width: 60px;
  height: 60px;
  left: 100px;
  background-color: skyblue;
}

.moved {
  transform: perspective(500px) translateZ(200px);
  background-color: pink;
}
</pre>

<p>What really matters here is the class "moved"; let's take a look at what it does. First, the <code><a href="/en-US/docs/Web/CSS/transform-function/perspective">perspective()</a></code> function positions the viewer relative to the plane that lies where z=0 (in essence, the surface of the screen). A value of <code>500px</code> means the user is 500 pixels "in front of" the imagery located at z=0.</p>

<p>Then, the <code>translateZ()</code> function moves the element 200 pixels "outward" from the screen, toward the user. This has the effect of making the element appear larger when viewed on a 2D display, or closer when viewed using a VR headset or other 3D display device.</p>

<p>Note if the <code>perspective()</code> value is less than the <code>translateZ()</code> value, such as <code>transform: perspective(200px) translateZ(300px);</code> the transformed element will not be visible as it is further than the user's viewport. The smaller the difference between the perspective and translateZ values, the closer the user is to the element and the larger the translated element will seem.</p>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Examples", 250, 250)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS Transforms 2', '#transform-functions', 'transform')}}</td>
   <td>{{Spec2('CSS Transforms 2')}}</td>
   <td>Adds 3D transform functions to the CSS Transforms standard.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.types.transform-function")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{cssxref("transform")}}</li>
 <li>{{cssxref("&lt;transform-function&gt;")}}</li>
</ul>
